
;**************************************************************************
;**
;** Disk
;**
;******

TmpZP		EQU	$fb
Tmp2ZP		EQU	$fd

;**************************************************************************
;**
;** InitTune  - clear the tune
;** InitTune2 - clear the tune (without asking)
;**
;******
InitTune:
	jsr	AreYouSure
	beq	it_ex1

InitTune2:
	ldx	#<TuneStart
	ldy	#>TuneStart
	stx	TmpZP
	sty	TmpZP+1

	ldy	#0
it_lp1:
	tya
	sta	(TmpZP),y
	inc	TmpZP
	bne	it_skp1
	inc	TmpZP+1
it_skp1:
	lda	TmpZP
	cmp	#<TuneEnd
	bne	it_lp1
	lda	TmpZP+1
	cmp	#>TuneEnd
	bne	it_lp1

; make pattern 01 a volume pattern with volume 0f
	ldx	#0
	lda	#$0f
it_lp2:
	sta	pl_PatternData+[$40*1],x
	inx
	inx
	cpx	#$40
	bne	it_lp2

; put pattern 01 in the volume track
	ldx	#0
	lda	#$01
it_lp3:
	sta	pl_Tab5,x
	inx
	bne	it_lp3
	
; set up version number and initial speed + start/stop step.
	jsr 	SetVersion

	lda	#1
	sta	pl_SongNum
	lda	#0
	sta	pl_StartStep
	sta	pl_EndStep
	lda	#7
	sta	pl_StartSpeed
it_ex1:
	rts

SetVersion:
	lda	#"T"
	sta	pl_ID
	lda	#"0"
	sta	pl_ID+1
	lda	#VERSION
	sta	pl_Version
	lda	#REVISION
	sta	pl_Revision
	rts

;**************************************************************************
;**
;** LoadTune
;**
;******
LoadTune:
	ldy	#0
	ldx	#20
	clc
	jsr	$fff0
	lda	#<LoadName_MSG
	ldy	#>LoadName_MSG
	jsr	$cb1e
	jsr	GetFileName
	cmp	#$00
	beq	lt_ex1


	lda	#1
	ldx	#8
	ldy	#0
	jsr	$ffba

	jsr	SetFileName

	lda	#$00
	sta	$90

	lda	#0
	ldx	#<TuneStart
	ldy	#>TuneStart
	jsr	$ffd5
		
lt_ex1:
	rts


;**************************************************************************
;**
;** SaveTune
;**
;******
SaveTune:
; Make sure you see which version created it.
	jsr	SetVersion

; save the data
	ldy	#0
	ldx	#20
	clc
	jsr	$fff0
	lda	#<SaveName_MSG
	ldy	#>SaveName_MSG
	jsr	$cb1e
	jsr	GetFileName
	cmp	#$00
	beq	st_ex1

	lda	#1
	ldx	#8
	ldy	#1
	jsr	$ffba

	jsr	SetFileName

	lda	#$00
	sta	$90

	jsr	FindTuneEnd

	lda	#<TuneStart
	sta	TmpZP
	lda	#>TuneStart
	sta	TmpZP+1

	lda	#TmpZP
	ldx	Tmp2ZP
	ldy	Tmp2ZP+1
	jsr	$ffd8	;Save

st_ex1:
	rts

;**************************************************************************
;*
;* Display Directory...
;*
;***
ShowDir:
	lda	#144
	jsr	$ffd2
	lda	#147
	jsr	$ffd2
	lda	#DnamLen
	ldx	#<Dnam
	ldy	#>Dnam
	jsr	$ffbd	;SETNAM
	lda	#$01
	ldx	$ba
	ldy	#$60
	jsr	$ffba	;SETLFS
	jsr	$ffc0	;iec-OPEN
	lda	$ba
	jsr	$ffb4	;TALK
	lda	$b9
	jsr	$ff96	;TKSA

	ldy	#$03
sd_lp1:	
	sty	$b7
sd_lp2:
	jsr	$ffa5	;ACPTR
	sta	$c3
	jsr	$ffa5	;ACPTR
	ldy	$90
	bne	sd_ex1
	dec	$b7
	bne	sd_lp2
	ldx	$c3
	jsr	$ddcd	;Output decimal number
	lda	#" "
	jsr	$ffd2	;pchar
sd_lp3:
	jsr	$ffa5	;ACPTR
	ldx	$90
	bne	sd_ex1
	cmp	#0
	beq	sd_skp1
	jsr	$ffd2	;pchar
	jmp	sd_lp3
sd_skp1:
	lda	#13
	jsr	$ffd2	;pchar
	ldy	#$02
sd_lp4:
	jsr	$ffe1	;STOP
	bne	sd_lp1
	jmp	sd_ex2

sd_ex1:
	jsr	sd_Close

	lda	#0
	sta	198
sd_lp5:
	jsr	$ffe4
	beq	sd_lp5
	rts

sd_ex2:
	jsr	sd_Close
	rts


sd_Close:
	jsr	$ffab	;UNTLK
	lda	#$01
	jsr	$ffc3	;iec-close
	jsr	$ffe7
	rts
;***
Dnam:
	dc.b	"$0"
DnamLen	EQU	.-Dnam





;**************************************************************************
;**
;** GetFileName
;**
;******
GetFileName:
	ldy	#0
gfn_lp1:
	jsr	$ffcf
	cmp	#13
	beq	gfn_ex1
	sta	FileName,y
	iny
	cpy	#16
	bne	gfn_lp1
gfn_ex1:
	lda	#0
	sta	FileName,y
	tya
	rts

;**************************************************************************
;**
;** SetFileName
;**
;******
SetFileName:
; Hitta namnlngd (dock lngst 16 tkn)
	ldx	#0
sfn_lp1:
	lda	FileName,x
	beq	sfn_ex1
	inx
	cpx	#16
	bne	sfn_lp1
sfn_ex1:
	txa
	ldx	#<FileName
	ldy	#>FileName
	jsr	$ffbd
	rts
;***
FileName:
	ds.b	17


LoadName_MSG:
	dc.b	144,"LOAD: ",0
SaveName_MSG:
	dc.b	144,"SAVE: ",0


;**************************************************************************
;**
;** FindTuneEnd
;**
;******
FindTuneEnd:
	lda	#0
	sta	MaxPatt
	lda	#<pl_PattLists
	sta	Tmp2ZP
	lda	#>pl_PattLists
	sta	Tmp2ZP+1
	ldx	#5
	ldy	#0
fte_lp1:
	lda	MaxPatt
	cmp	(Tmp2ZP),y
	bcs	fte_skp1
	lda	(Tmp2ZP),y
fte_skp1:
	sta	MaxPatt
	iny
	bne	fte_lp1
	inc	Tmp2ZP+1
	dex
	bne	fte_lp1


	lda	#0
	sta	Tmp2ZP+1
	inc	MaxPatt
	lda	MaxPatt
	asl
	rol	Tmp2ZP+1
	asl
	rol	Tmp2ZP+1
	asl
	rol	Tmp2ZP+1
	asl
	rol	Tmp2ZP+1
	asl
	rol	Tmp2ZP+1
	asl
	rol	Tmp2ZP+1
	clc
	adc	#<pl_PatternData
	sta	Tmp2ZP
	lda	Tmp2ZP+1
	adc	#>pl_PatternData
	sta	Tmp2ZP+1
	rts

MaxPatt:
	dc.b	0
