
PattZP		EQU	$fb
VoiceZP		EQU	$fd
VoiceZP2	EQU	$f9
ConvZP		EQU	$f8

;**************************************************************************
;**
;** EditPattern
;**
;******
EditPattern:
;	lda	#EDIT_PATTERN
;	sta	EditMode

	jsr	UnEdit


	ldx	#4
edp_lp2:
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_PatternTabLOW],y
	sta	PattZP
	lda	[pl_VoiceData+vd_PatternTabHIGH],y
	sta	PattZP+1
	ldy	epl_CurrentLine
	lda	(PattZP),y
	sta	EditRow,x
	dex
	bpl	edp_lp2

	ldy	#2
	ldx	#0
edp_lp3:
	lda	#0
	sta	PattZP+1
	lda	EditRow,x
	asl
	rol	PattZP+1
	asl
	rol	PattZP+1
	asl
	rol	PattZP+1
	asl
	rol	PattZP+1
	asl
	rol	PattZP+1
	asl
	rol	PattZP+1
	clc
	adc	#<pl_PatternData
	sta	PattZP
	lda	PattZP+1
	adc	#>pl_PatternData
	sta	PattZP+1

	lda	PattZP
	sta	edp_AddressTabLOW,y
	sta	edp_AddressTabLOW+1,y
	lda	PattZP+1
	sta	edp_AddressTabHIGH,y
	sta	edp_AddressTabHIGH+1,y
	iny
	iny
	inc	PattZP
	bne	edp_skp1
	inc	PattZP+1
edp_skp1:
	lda	PattZP
	sta	edp_AddressTabLOW,y
	sta	edp_AddressTabLOW+1,y
	lda	PattZP+1
	sta	edp_AddressTabHIGH,y
	sta	edp_AddressTabHIGH+1,y
	iny
	iny

	inx
	cpx	#5
	bne	edp_lp3
	

	ldx	#0
edp_lp1:
	lda	edp_INFOBLOCK,x
	sta	INFOBLOCK,x
	inx
	cpx	#ib_sizeof
	bne	edp_lp1

	jsr	StartEdit
	rts

UnEditPattern:
	ldx	#0
uedp_lp1:
	lda	INFOBLOCK,x
	sta	edp_INFOBLOCK,x
	inx
	cpx	#ib_sizeof
	bne	uedp_lp1

	rts

edp_Screen:	
	ldy	#0
	lda	#$20
	sta	(ScreenZP),y
	iny
	sta	(ScreenZP),y
	iny
	ldx	#0
edps_lp1:
	lda	#30	;pilupp
	sta	(ScreenZP),y
	iny
	lda	EditRow,x
	jsr	PutHex
	lda	#" "
	sta	(ScreenZP),y
	iny
	inx
	cpx	#5
	bne	edps_lp1
	rts

edp_Update:
	rts

edp_CheckKeys:
	cmp	#"R"
	beq	edpc_Arp
	cmp	#13
	beq	edpc_Edit
	cmp	#0
	rts
edpc_Edit:
	jsr	EditPattList
	jsr	ToggleCursor
	jmp	edpc_ex1
edpc_Arp:
	jsr	EditArp
	jsr	ToggleCursor
edpc_ex1:
	lda	#0
	rts

EditRow:
	dc.b	0,0,0,0,0



edp_INFOBLOCK:
;*** THE INFO BLOCK ***
edp_EditMode:
	dc.b	EDIT_PATTERN
; The line we are editing (in the middle of the edit area)
edp_CurrentLine:
	dc.b	0
; The column we are editing
edp_CurrentColumn:
	dc.b	2
; When a character was entered where should we go?
; any nonzero here will make it down else right
edp_AdvanceMode:
	dc.b	0
edp_EditStep:
	dc.b	1
edp_InitRoutine:
	dc.w	EditPattern
edp_ScreenRoutine:
	dc.w	edp_Screen
edp_UpdateRoutine:
	dc.w	edp_Update
edp_KeyRoutine:
	dc.w	edp_CheckKeys
edp_TermRoutine:
	dc.w	UnEditPattern
edp_Length:
	dc.b	32-1
; Number of shifts
edp_Step:
	dc.b	1
edp_ColorTab:
	dc.b	0,0,2,2,2,2,6,6,6,6,2,2,2,2,6,6,6,6,2,2,2,2
edp_CursorTab:
	dc.b	5,4,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2,3,2
edp_AddressTabLOW:
	ds.b	22
edp_AddressTabHIGH:
	ds.b	22

