;**************************************************************************
;**
;** Keys.asm
;**
;******


;**************************************************************************
;**
;** Docs
;**
;******
CheckDocKeys:
	cmp	#"H"
	beq	cdk_ShowDoc

	cmp	#0
	rts

cdk_ShowDoc:
	jsr	ViewDocs
	jsr	ShowScreen
	jsr	StartEdit
	lda	#0
	rts

;**************************************************************************
;**
;** PlayerStuff
;**
;******
CheckPlayKeys:
	cmp	#"M"
	beq	cpk_InitMusic

	cmp	#"P"
	beq	cpk_ToggleMusic

	cmp	#0
	rts

cpk_InitMusic:
	jsr	pl_Init
	jmp	cpk_ex1

cpk_ToggleMusic:
	lda	pl_PlayFlag
	eor	#$ff
	pha
	jsr	pl_Init
	pla
	sta	pl_PlayFlag

cpk_ex1:
	lda	#0
	rts


;**************************************************************************
;**
;** DiskStuff
;**
;******
CheckDiskKeys:
	cmp	#204	;Shift L
	beq	cdk_LoadTune

	cmp	#211	;Shift S
	beq	cdk_SaveTune

	cmp	#196	;Shift D
	beq	cdk_Directory

	cmp	#201	;Shift I
	beq	cdk_InitTune
	cmp	#0
	rts

cdk_LoadTune:
	jsr	LoadTune
	jmp	cdk_ex1

cdk_SaveTune:
	jsr	SaveTune
	jmp	cdk_ex1

cdk_Directory:
	jsr	ShowDir
	lda	#147
	jsr	$ffd2
	jmp	cdk_ex1

cdk_InitTune:
	jsr	InitTune

cdk_ex1:
	jsr	ShowScreen
	jsr	StartEdit
	lda	#0
	rts


;**************************************************************************
;**
;** Function keys
;**
;******
CheckEditKeys:
	cmp	#133	;F1
	beq	cek_SetStep
	cmp	#134	;F3
	beq	cek_SetStartStep
	cmp	#135	;F5
	beq	cek_SetEndStep

	cmp	#136	;F7
	beq	cek_IncSpeed
	cmp	#140	;F8
	beq	cek_DecSpeed
	cmp	#0
	rts

cek_SetStep:
	jsr	pl_Init
	lda	LastPattListLine
	sta	pl_Step
	lda	#0
	sta	pl_PatternPos
	jmp	cek_ex1


cek_SetStartStep:
	lda	LastPattListLine
	sta	pl_StartStep
	jmp	cek_ex1

cek_SetEndStep:
	lda	LastPattListLine
	sta	pl_EndStep
	jmp	cek_ex1

cek_IncSpeed:
	inc	pl_StartSpeed
	jmp	cek_ex1
cek_DecSpeed:
	dec	pl_StartSpeed
cek_ex1:
	lda	#0
	rts
