;**************************************************************************
;**
;** FILE  musiced.asm
;** Copyright (c) 1994, 2001 Daniel Kahlin
;** Written by Daniel Kahlin <daniel@kahlin.net>
;**
;** DESCRIPTION
;**   The main source of the vic-tracker music editor for the
;**   Commodore Vic20.  Atleast 16KB memory required!
;**
;** Revision History
;** 940629 00:00 - 02:52  :  First Test version.  Edit works ok small player.
;** 940629 12:43 - 18:00  :  Version 2 funkar bttre. packat data funkar inte alls
;** 940630 23:00 - 01:52  :  Visar step, patternpos, load och save funkar
;**                          Format fixning behvs!!!!
;** 940630 17:40 - 21:29  :  Div
;** 940701 23:00 - 03:20  :  Generell edit funkar!
;** 940702 23:20 - 00:50  :  Fix av edit lngd   Save lngd fix!!!
;** 940703 21:54 - 00:54  :  +fotboll  F-tangenter funkar bra
;** 010719-010721         :  Fintrimmning och intro + docs & mer!
;**
;******
	PROCESSOR 6502


VERSION		EQU	1
REVISION	EQU	0


;the length of a screen in cycles
SCREENTIME	EQU	22150

PlayColor	EQU	$e3+8
NormalColor	EQU	$e6+8

ScreenRAM	EQU	$1000	;$1e00
ColorRAM	EQU	$9400	;$9600


ColorZP		EQU	$ac
ScreenZP	EQU	$ae
PokeZP		EQU	$fb
DocZP		EQU	$fe

EDIT_PATTLIST	EQU	0
EDIT_PATTERN	EQU	1
EDIT_ARP	EQU	2


	seg	code
	org	$1201
;**************************************************************************
;**
;** Basic line!
;**
;******
StartOfFile:
	dc.w	EndLine
SumStart:
	dc.w	2001
	dc.b	$9e,"(4628) AR89",0
;	     2001 SYS(4628) AR89
;			 44444444444
;			 66666666666
;			 22222222233
;			 12345678901
EndLine:
	dc.w	0

;**************************************************************************
;**
;** SysAddress... When run we will enter here!
;**
;******
SysAddress:
	jsr	VideoInit
	sei
	jsr	InterruptInit
	cli

	lda	#255
	sta	650	;Keyrepeat

; clear the song, when run the first time
sa_fix:
	jsr	InitTune2
	lda	#$2c
	sta	sa_fix

	jsr	ResetEditor	;Mste kras frst av editor rutinerna!!!
	jsr	ShowScreen

; setup doc pointer
	jsr	InitDocs

;*** The EditMode ***
	jsr	EditPattList

MainLoop2:
	jsr	InitEditor
	jsr	StartEdit
MainLoop:
	jsr	ShowInfo
ml_lp1:
	jsr	PrintPlayer
	jsr	$ffe4	;Wait for key
	beq	ml_lp1

	jsr	EditRoutine

	jsr	CheckPlayKeys
	jsr	CheckDiskKeys
	jsr	CheckEditKeys
	jsr	CheckDocKeys

	jmp	MainLoop


;**************************************************************************
;**
;** Initialize Video!
;**
;******
VideoInit:
	lda	#147
	jsr	$ffd2

	ldx	#0
vi_lp1:
	lda	#$00
	sta	ColorRAM,x
	sta	ColorRAM+256,x
	lda	#$20
	sta	ScreenRAM,x
	sta	ScreenRAM+256,x
	inx
	bne	vi_lp1

	lda	#NormalColor
	sta	$900f

	rts




;**************************************************************************
;**
;** Initialize Interrupts!
;**
;******
InterruptInit:
	lda	#$7f
	sta	$912e
	sta	$912d
	lda	#%11000000
	sta	$912e
	lda	#%01000000
	sta	$912b
	lda	#<IRQServer
	sta	$0314
	lda	#>IRQServer
	sta	$0315

	lda	#268/2
	jsr	WaitLine

	
	lda	#<SCREENTIME
	sta	$9124
	lda	#>SCREENTIME
	sta	$9125	;load T1
	rts


;**************************************************************************
;**
;** Wait until line ACC is passed
;**
;******
WaitLine:
s_lp2:
	cmp	$9004
	bne	s_lp2
s_lp3:
	cmp	$9004
	beq	s_lp3
	rts



;**************************************************************************
;**
;** IRQ Interrupt server
;**
;******
IRQServer:
	lda	$912d
	asl
	asl
	bcc	irq_ex1
	jsr	T1Timeout
	lda	$9124
irq_ex1:
	jmp	$eabf




;**************************************************************************
;**
;** Routines + stuff
;**
;******
T1Timeout:
	lda	#PlayColor
;	sta	$900f

	jsr	pl_Play

	lda	#NormalColor
;	sta	$900f
	rts





;**************************************************************************
;**
;** Ask: Are You Sure
;**
;******
AreYouSure:
	ldx	#21
ays_lp2:
	lda	AreYouSure_MSG,x
	and	#$3f
	sta	ScreenRAM+22*20,x
	dex
	bpl	ays_lp2

ays_lp1:
	jsr	$ffe4
	beq	ays_lp1
	pha
	jsr	BlankStatus
	pla
	cmp	#"Y"
	beq	ays_ex1
	lda	#0
	rts
ays_ex1:
	lda	#$ff
	rts

AreYouSure_MSG:
	dc.b	" ARE YOU SURE?  (Y/N) "




;**************************************************************************
;**
;** Includes
;**
;******
	include screen.asm
	include	keys.asm
	include	disk.asm
	include	editor.asm
	include	editpattern.asm
	include	editpattlist.asm
	include	editarp.asm
	include	docs.asm
	include	player.asm
EditorEnd:
	include	playerdata.asm

	echo "Editor    :",StartOfFile,"-",EditorEnd
	echo "Docs      :",Docs,"-",DocsEnd
	echo "Data (BSS):",TuneStart,"-",TuneEnd
