;**************************************************************************
;**
;** Player
;**
;******

vd_PatternTabLOW	EQU	0
vd_PatternTabHIGH	EQU	1
vd_Note			EQU	2
vd_Param		EQU	3
vd_FreqOffset		EQU	4
vd_FreqOffsetHigh	EQU	5
vd_ArpStep		EQU	6
vd_ArpOffset		EQU	7
vd_Sizeof		EQU	8

PatternZP	EQU	$b0
PatternTabZP	EQU	$b2
pl_Temp1ZP	EQU	$b4


;**************************************************************************
;**
;** JumpTable
;**
;******
pl_Init:
	jmp	pl_IInit
pl_Play:
	jmp	pl_PPlay




;**************************************************************************
;**
;** Data (re sant, jag som trodde det var kod... /Johan)
;**
;******
pl_PlayFlag:
	dc.b	0
pl_Speed:
	dc.b	0
pl_Count:
	dc.b	0
pl_Step:
	dc.b	0
pl_PatternPos:
	dc.b	0

pl_VoiceOffset:
	dc.b	vd_Sizeof*0
	dc.b	vd_Sizeof*1
	dc.b	vd_Sizeof*2
	dc.b	vd_Sizeof*3
	dc.b	vd_Sizeof*4
pl_ConvTab:
	dc.b	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
	dc.b	1,2,3,4,5,6,7,8,9,10,11,12,0,0,0,0
	dc.b	13,14,15,16,17,18,19,20,21,22,23,24,0,0,0,0
	dc.b	25,26,27,28,29,30,31,32,33,34,35,36,0,0,0,0
	dc.b	37,38,0,0,0,0,0,0,0,0,0,0,0,0,0,0
pl_FreqTab:
	dc.b	0
	dc.b	135,143,147,151,159,163,167,175,179,183,187,191
	dc.b	195,199,201,203,207,209,212,215,217,219,221,223
	dc.b	225,227,228,229,231,232,233,235,236,237,238,239
	dc.b	240,241

pl_VoiceData:
	dc.w	pl_Tab1
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.w	pl_Tab2
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.w	pl_Tab3
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.w	pl_Tab4
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.w	pl_Tab5
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0



;**************************************************************************
;**
;** InitRoutine
;**
;******
pl_IInit:
	lda	#0
	sta	$900a
	sta	$900b
	sta	$900c
	sta	$900d
	lda	$900e
	and	#$f0
	sta	$900e
	lda	pl_StartSpeed
	sta	pl_Speed
	lda	pl_StartStep
	sta	pl_Step
	lda	#0
	sta	pl_PatternPos
	sta	pl_Count
	lda	#$ff
	sta	pl_PlayFlag

	ldx	#4
pli_lp1:
	ldy	pl_VoiceOffset,x
	lda	#0
	sta	[pl_VoiceData+vd_Note],y
	sta	[pl_VoiceData+vd_Param],y
	sta	[pl_VoiceData+vd_FreqOffset],y
	sta	[pl_VoiceData+vd_FreqOffsetHigh],y
	sta	[pl_VoiceData+vd_ArpStep],y
	sta	[pl_VoiceData+vd_ArpOffset],y
	dex
	bpl	pli_lp1

	rts



;**************************************************************************
;**
;** PlayRoutine
;**
;******
pl_PPlay:
	lda	pl_PlayFlag
	beq	plpp_ex1

	dec	pl_Count
	bmi	pl_skp1
	jmp	pl_ex1
plpp_ex1:
	rts

pl_skp1:

;*** Get Data from tune ***
	ldx	#4
pl_lp1:
	jsr	pl_GetVoice
	jsr	pl_Retrig
	dex
	bpl	pl_lp1

;*** Check if effects ***
	ldx	#4
pl_lp2:
	jsr	pl_CheckEffects
	dex
	bpl	pl_lp2

	lda	pl_Speed
	sta	pl_Count

;*** Handle position ***
	inc	pl_PatternPos
	lda	pl_PatternPos
	and	#$1f
	sta	pl_PatternPos
	bne	pl_ex1

	lda	pl_Step
	inc	pl_Step
	cmp	pl_EndStep
	bne	pl_ex1
	lda	pl_StartStep
	sta	pl_Step

pl_ex1:

;*** play the voices ***
	ldx	#4
pl_lp3:
	jsr	pl_PlayVoice
	jsr	pl_UpdateVoice
	dex
	bpl	pl_lp3

	rts



;**************************************************************************
;**
;** GetVoice
;** X=Voice
;**
;******
pl_GetVoice:

;*** Get Pointer To PatternTab ***
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_PatternTabLOW],y
	sta	PatternTabZP
	lda	[pl_VoiceData+vd_PatternTabHIGH],y
	sta	PatternTabZP+1

;*** Get Address to Current Pattern ***
	ldy	pl_Step
	lda	#0
	sta	PatternZP+1
	lda	(PatternTabZP),y
	asl
	rol	PatternZP+1
	asl
	rol	PatternZP+1
	asl
	rol	PatternZP+1
	asl
	rol	PatternZP+1
	asl
	rol	PatternZP+1
	asl
	rol	PatternZP+1
	clc
	adc	#<pl_PatternData
	sta	PatternZP
	lda	PatternZP+1
	adc	#>pl_PatternData
	sta	PatternZP+1

;*** Get Current NOTE and PARAM from Pattern ***
	lda	pl_PatternPos
	asl
	tay
	lda	(PatternZP),y
	pha
	iny
	lda	(PatternZP),y
	ldy	pl_VoiceOffset,x
	sta	[pl_VoiceData+vd_Param],y
	pla

	cmp	#$80	;LastNote
	beq	plgv_skp3
	
	pha
	and	#$80
	sta	pl_Temp1ZP
	pla

	cpx	#$03
	bcs	plgv_skp1
	and	#$7f
	tay
	lda	pl_ConvTab,y
plgv_skp1:
	and	#$7f
	ora	pl_Temp1ZP
	ldy	pl_VoiceOffset,x
	sta	[pl_VoiceData+vd_Note],y
plgv_ex1:

	rts

plgv_skp3:
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_Note],y
	ora	#$80
	sta	[pl_VoiceData+vd_Note],y
	rts



;**************************************************************************
;**
;** Retrig
;** X=Voice
;**
;******
pl_Retrig:
	pha
	tya
	pha
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_Note],y
	bmi	plrt_ex1

	lda	#0
	sta	[pl_VoiceData+vd_FreqOffset],y
	sta	[pl_VoiceData+vd_FreqOffsetHigh],y
	sta	[pl_VoiceData+vd_ArpStep],y
	sta	[pl_VoiceData+vd_ArpOffset],y

	lda	[pl_VoiceData+vd_Param],y
	and	#$f0
	cmp	#$30
	bne	plrt_ex1
	lda	[pl_VoiceData+vd_Param],y
	asl
	asl
	asl
	tay
	lda	pl_Arpeggios,y
	ldy	pl_VoiceOffset,x
	sta	[pl_VoiceData+vd_ArpOffset],y

plrt_ex1:
	pla
	tay
	pla
	rts


;**************************************************************************
;**
;** CheckEffects
;** X=Voice
;**
;******
pl_CheckEffects:

;*** Get VoiceData ***
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_Note],y
	and	#$7f
	cpx	#$04
	beq	plce_VolumeTempo


	rts

plce_VolumeTempo:
	and	#$f0
	beq	plcevt_ex1
	lsr
	lsr
	lsr
	lsr
	sta	pl_Speed
plcevt_ex1:
	rts


;**************************************************************************
;**
;** PlayVoice
;** X=Voice
;**
;******
pl_PlayVoice:

;*** Get VoiceData ***
	ldy	pl_VoiceOffset,x

;Calculate FreqOffset/2 (Signed) and put in pl_Temp1ZP
	lda	[pl_VoiceData+vd_FreqOffset],y
	sta	pl_Temp1ZP
	lda	[pl_VoiceData+vd_FreqOffsetHigh],y
	lsr
	ror	pl_Temp1ZP
	lsr
	ror	pl_Temp1ZP
	lsr
	ror	pl_Temp1ZP
	lsr
	ror	pl_Temp1ZP

;Get note in ACC and jump
	lda	[pl_VoiceData+vd_Note],y
	and	#$7f
	cpx	#$04			;Is VOL?
	beq	plpv_VolumeTempo
	cpx	#$03			;Is noise?
	beq	plpv_Noise

;*** Play Note ***
	clc
	adc	[pl_VoiceData+vd_ArpOffset],y	;Add Arpeggio
	tay
	lda	pl_FreqTab,y
	beq	plpv_skp1
	clc
	adc	pl_Temp1ZP
	ora	#$80
plpv_skp1:
	sta	$900a,x
	rts

plpv_Noise:
;*** Play Noise ***
	cmp	#$00
	beq	pplvn_skp1
	clc
	adc	[pl_VoiceData+vd_ArpOffset],y	;Add arpeggio
	clc
	adc	pl_Temp1ZP
	ora	#$80		;SetGate
pplvn_skp1:
	sta	$900a,x
	rts

plpv_VolumeTempo:
;*** Handle Volume ***

	and	#$0f
	sta	pl_Temp1ZP
	lda	$900e
	and	#$f0
	ora	pl_Temp1ZP
	sta	$900e
pplvv_ex1:
	rts



;**************************************************************************
;**
;** UpdateVoice
;** X=Voice
;**
;******
pl_UpdateVoice:

;*** Fix Effects ***
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_Param],y
	pha
	and	#$0f
	sta	pl_Temp1ZP
	pla
	and	#$f0
	cmp	#$10
	beq	pl_PortamentoUp
	cmp	#$20
	beq	pl_PortamentoDown
	cmp	#$30
	beq	pl_Arpeggio
	cmp	#$50
	beq	pl_PortamentoUpSlow
	cmp	#$60
	beq	pl_PortamentoDownSlow

	rts

pl_PortamentoUp:
	asl	pl_Temp1ZP
	asl	pl_Temp1ZP
	asl	pl_Temp1ZP
	lda	[pl_VoiceData+vd_FreqOffset],y
	clc
	adc	pl_Temp1ZP
	sta	[pl_VoiceData+vd_FreqOffset],y
	lda	[pl_VoiceData+vd_FreqOffsetHigh],y
	adc	#0
	sta	[pl_VoiceData+vd_FreqOffsetHigh],y
	rts
pl_PortamentoDown:
	asl	pl_Temp1ZP
	asl	pl_Temp1ZP
	asl	pl_Temp1ZP
	lda	[pl_VoiceData+vd_FreqOffset],y
	sec
	sbc	pl_Temp1ZP
	sta	[pl_VoiceData+vd_FreqOffset],y
	lda	[pl_VoiceData+vd_FreqOffsetHigh],y
	sbc	#0
	sta	[pl_VoiceData+vd_FreqOffsetHigh],y
	rts
pl_PortamentoUpSlow:
	asl	pl_Temp1ZP
	lda	[pl_VoiceData+vd_FreqOffset],y
	clc
	adc	pl_Temp1ZP
	sta	[pl_VoiceData+vd_FreqOffset],y
	lda	[pl_VoiceData+vd_FreqOffsetHigh],y
	adc	#0
	sta	[pl_VoiceData+vd_FreqOffsetHigh],y
	rts
pl_PortamentoDownSlow:
	asl	pl_Temp1ZP
	lda	[pl_VoiceData+vd_FreqOffset],y
	sec
	sbc	pl_Temp1ZP
	sta	[pl_VoiceData+vd_FreqOffset],y
	lda	[pl_VoiceData+vd_FreqOffsetHigh],y
	sbc	#0
	sta	[pl_VoiceData+vd_FreqOffsetHigh],y
	rts
pl_Arpeggio:
	lda	[pl_VoiceData+vd_ArpStep],y
	and	#%111
	clc
	adc	#1
	sta	[pl_VoiceData+vd_ArpStep],y
	asl	pl_Temp1ZP
	asl	pl_Temp1ZP
	asl	pl_Temp1ZP
	clc
	adc	pl_Temp1ZP
	tay
	lda	pl_Arpeggios,y
	ldy	pl_VoiceOffset,x
	sta	[pl_VoiceData+vd_ArpOffset],y
	rts
