;**************************************************************************
;**
;** MusicED Vic20
;**
;******

;**************************************************************************
;**
;** ShowEditScreen
;**
;******
ShowScreen:
	ldx	#22*11
ss_lp2:
	lda	Screen-1,x
	cmp	#"A"
	bcc	ss_skp1
	cmp	#"Z"+1
	bcs	ss_skp1
	and	#$3f	
ss_skp1:
	sta	ScreenRAM+22*10-1,x
	lda	#0
	sta	ColorRAM+22*10-1,x
	dex	
	bne	ss_lp2

	jsr	BlankStatus
	ldx	#44-1
ss_lp1:
	lda	Bonus_MSG,x
	and	#$3f
	ora	#$80
	sta	ScreenRAM+22*21,x
	lda	#6
	sta	ColorRAM+22*21,x
	dex
	bpl	ss_lp1
	rts


Bonus_MSG:
	dc.b	"                      "
	dc.b	"   VIC-TRACKER 1.0!   "

;**************************************************************************
;**
;** ShowInfo
;**
;******
ShowInfo:
	jsr	PrintEditMode

	rts

;**************************************************************************
;**
;** Print PlayerData
;**
;******
PrintPlayer:
	lda	#<[ScreenRAM+22*13]
	sta	ScreenZP
	lda	#>[ScreenRAM+22*13]
	sta	ScreenZP+1
	ldy	#19
	lda	pl_Step
	jsr	PutHex
	ldy	#19+22*1
	lda	pl_PatternPos
	jsr	PutHex
	ldy	#19+22*2
	lda	pl_Speed
	jsr	PutHex

	ldy	#13
	lda	#"."
	ldx	pl_PlayFlag
	beq	ppl_skp1
	lda	#"P"&$3f
ppl_skp1:
	sta	(ScreenZP),y

	ldy	#5
	lda	pl_StartStep
	jsr	PutHex
	ldy	#5+22*1
	lda	pl_EndStep
	jsr	PutHex
	ldy	#5+22*2
	lda	pl_StartSpeed
	jsr	PutHex
	rts


;**************************************************************************
;**
;** Print EditMode
;**
;******
PrintEditMode:
	lda	#<[ScreenRAM+22*11]
	sta	ScreenZP
	lda	#>[ScreenRAM+22*11]
	sta	ScreenZP+1

	ldy	#4
	lda	#"R"&$3f
	ldx	AdvanceMode
	beq	pem_skp1
	lda	#"D"&$3f
pem_skp1:
	sta	(ScreenZP),y

	ldy	#9
	lda	EditStep
	jsr	PutNybble

	rts


;**************************************************************************
;**
;** BlankStatusLine
;**
;******
BlankStatus:
	ldx	#21
	lda	#$20
bs_lp1:
	sta	ScreenRAM+22*20,x
	dex
	bpl	bs_lp1
	rts



Screen:
	dc.b	"p@@@@r@@@@r@@@@@@@@@@n"
	dc.b	"]AM R]ST 0] 'H'=HELP ]"
	dc.b	"k@@@@q@r@@q@@@r@@@@@@s"
	dc.b	"]FST 00]PMOD .]STP 00]"
	dc.b	"]LST 00k@@@@@@sPOS 00]"
	dc.b	"]SPD 00]>AR89<]SPD 00]"
	dc.b	"k@@@@@@q@@@@@@q@@@@@@s"
	dc.b	"]CODE: D KAHLIN (TLR)]"
	dc.b	"]HELP: WALLSTROM(K12)]"
	dc.b	"m@@@@@@@@@@@@@@@@@@@@}"
	dc.b	"                      "



; Tecken
;
; @ horisontellt
; ] lodrt
; k lodrt-V
; s lodrt-H
; q horisontellt-N
; r horisontellt-U
; p V-hrn
; n H-hrn
; m NV-hrn
; } NH-hrn
;  Jtteplus
;
