;**************************************************************************
;**
;** FILE  player.asm
;** Copyright (c) 1994, 2001 Daniel Kahlin
;** Written by Daniel Kahlin <daniel@kahlin.net>
;**
;** DESCRIPTION
;**   Player for vic-tracker tunes packed by vtcomp.
;**   Nice huh?
;**
;**   Initialize tune:
;**     jsr pl_Init 
;**
;**   Every frame:
;**     jsr pl_Play
;**
;******

vd_PatternTabLOW	EQU	0	;pointer to Pattlist
vd_PatternTabHIGH	EQU	1	;
vd_Note			EQU	2	;Current Pitch
vd_Param		EQU	3	;Current Param
vd_FreqOffset		EQU	4	;Current freqoffset
vd_FreqOffsetHigh	EQU	5	;Current freqoffset
vd_ArpStep		EQU	6	;Arpeggio step
vd_ArpOffset		EQU	7	;Arpeggio offset
vd_PattlistStep		EQU	8	;Step in pattlist
vd_PattlistWait		EQU	9	;Time before reading the next pattlist
                                        ;entry
vd_CurrentPattern	EQU	10
vd_PatternStep		EQU	11	;Step in pattern
vd_PatternWait		EQU	12	;Time before reading the next note.
vd_FetchMode		EQU	13	;Fetch mode.
vd_Sizeof		EQU	14


	MAC	VD
	dc.w	pl_Tab{1}
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	ENDM


PatternZP	EQU	$b0
PatternTabZP	EQU	$b2
pl_Temp1ZP	EQU	$b4
pl_Temp2ZP	EQU	$fb



;**************************************************************************
;**
;** JumpTable
;**
;******
pl_Init:
	jmp	pl_IInit
pl_Play:
	jmp	pl_PPlay




;**************************************************************************
;**
;** Data (re sant, jag som trodde det var kod... /Johan)
;**
;******
pl_PlayFlag:
	dc.b	0
pl_Speed:
	dc.b	0
pl_Count:
	dc.b	0
pl_VoiceOffset:
	dc.b	vd_Sizeof*0
	dc.b	vd_Sizeof*1
	dc.b	vd_Sizeof*2
	dc.b	vd_Sizeof*3
	dc.b	vd_Sizeof*4
pl_FreqTab:
	dc.b	0
	dc.b	135,143,147,151,159,163,167,175,179,183,187,191
	dc.b	195,199,201,203,207,209,212,215,217,219,221,223
	dc.b	225,227,228,229,231,232,233,235,236,237,238,239
	dc.b	240,241
pl_VoiceData:
	VD	0
	VD	1
	VD	2
	VD	3
	VD	4


;**************************************************************************
;**
;** InitRoutine
;**
;******
pl_IInit:
	lda	#0
	sta	$900a
	sta	$900b
	sta	$900c
	sta	$900d
	lda	$900e
	and	#$f0
	sta	$900e

	lda	pl_StartSpeed
	sta	pl_Speed
	lda	#0
	sta	pl_Count
	lda	#$ff
	sta	pl_PlayFlag

	ldx	#4
pli_lp1:
	ldy	pl_VoiceOffset,x
	lda	#0
	sta	[pl_VoiceData+vd_Note],y
	sta	[pl_VoiceData+vd_Param],y
	sta	[pl_VoiceData+vd_FreqOffset],y
	sta	[pl_VoiceData+vd_FreqOffsetHigh],y
	sta	[pl_VoiceData+vd_ArpStep],y
	sta	[pl_VoiceData+vd_ArpOffset],y
	sta	[pl_VoiceData+vd_PattlistStep],y
	sta	[pl_VoiceData+vd_PattlistWait],y
	sta	[pl_VoiceData+vd_CurrentPattern],y
	sta	[pl_VoiceData+vd_PatternStep],y
	sta	[pl_VoiceData+vd_PatternWait],y
	lda	#$80
	sta	[pl_VoiceData+vd_FetchMode],y
	dex
	bpl	pli_lp1

	rts



;**************************************************************************
;**
;** PlayRoutine
;**
;******
pl_PPlay:
	lda	pl_PlayFlag
	beq	plpp_ex1

	dec	pl_Count
	bmi	pl_skp1
	jmp	pl_ex1
plpp_ex1:
	rts

pl_skp1:

;*** Get Data from tune ***
	ldx	#4
pl_lp1:
	jsr	pl_GetVoice
	jsr	pl_Retrig
	dex
	bpl	pl_lp1

;*** Check if effects ***
	ldx	#4
pl_lp2:
	jsr	pl_CheckEffects
	dex
	bpl	pl_lp2

	lda	pl_Speed
	sta	pl_Count

pl_ex1:
;*** play the voices ***
	ldx	#4
pl_lp3:
	jsr	pl_PlayVoice
	jsr	pl_UpdateVoice
	dex
	bpl	pl_lp3

	rts



;**************************************************************************
;**
;** GetVoice
;** X=Voice
;**
;******
pl_GetVoice:

;*** Get Pointer To PatternTab ***
	ldy	pl_VoiceOffset,x

	lda	[pl_VoiceData+vd_FetchMode],y
	cmp	#$80		;Fetch new pattern?
	bne	plgv_skp4	;No... skip

plgv_lp3:
	lda	[pl_VoiceData+vd_PattlistWait],y
	beq	plgv_skp5
	sec
	sbc	#1
	sta	[pl_VoiceData+vd_PattlistWait],y
	jmp	plgv_skp4

plgv_skp5:
	lda	[pl_VoiceData+vd_PatternTabLOW],y
	sta	PatternTabZP
	lda	[pl_VoiceData+vd_PatternTabHIGH],y
	sta	PatternTabZP+1
	lda	#0
	sta	pl_Temp1ZP

;*** Get Address to Current Pattern ***
	lda	[pl_VoiceData+vd_PattlistStep],y
	tay
plgv_lp1:
	lda	(PatternTabZP),y
	iny
	cmp	#$c0	;Repeat
	bne	plgv_skp1	
	ldy	#0		;Starta om
	beq	plgv_lp1	;stmman
plgv_skp1:
	cmp	#$c1	;End
	bne	plgv_skp2	
	ldy	#0		;Starta om
	sty	pl_PlayFlag	;stmman
	beq	plgv_lp1	;och stng av lt.
plgv_skp2:
	cmp	#0	;Test a!
	bpl	plgv_skp3
		
	and	#$3f
	sta	pl_Temp1ZP
	lda	(PatternTabZP),y
	iny
plgv_skp3:
	sta	pl_Temp2ZP

	tya
	ldy	pl_VoiceOffset,x
	sta	[pl_VoiceData+vd_PattlistStep],y
	lda	pl_Temp1ZP
	sta	[pl_VoiceData+vd_PattlistWait],y
	lda	pl_Temp2ZP
	sta	[pl_VoiceData+vd_CurrentPattern],y

plgv_skp4:
;*** fixa pattern adress ***

	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_CurrentPattern],y
	asl
	tay
	lda	pl_Patterns,y
	sta	PatternZP
	lda	pl_Patterns+1,y
	sta	PatternZP+1


;*** Get Current NOTE and PARAM from Pattern ***
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_PatternWait],y
	beq	plgv_skp6
	sec
	sbc	#1
	sta	[pl_VoiceData+vd_PatternWait],y
	jmp	plgv_skp8

plgv_skp6:

;*** Interpret pattern data ***
	lda	[pl_VoiceData+vd_PatternStep],y
	tay
	lda	(PatternZP),y	;Get Codebyte
	iny
	sta	pl_Temp1ZP
	and	#%11100000
	sta	pl_Temp2ZP
	cmp	#$80		;End of pattern?
	bne	plgv_skp7	;no... skip!

	ldy	pl_VoiceOffset,x
	sta	[pl_VoiceData+vd_FetchMode],y
	lda	#0
	sta	[pl_VoiceData+vd_PatternStep],y
	sta	[pl_VoiceData+vd_PatternWait],y
	jmp	plgv_lp3	; Fetch new pattern

plgv_skp7:
	
	tya
	ldy	pl_VoiceOffset,x
	sta	[pl_VoiceData+vd_PatternStep],y
	lda	pl_Temp1ZP
	and	#$1f
	sta	[pl_VoiceData+vd_PatternWait],y
	lda	pl_Temp2ZP
	sta	[pl_VoiceData+vd_FetchMode],y
	jsr	pl_Fetch
	jmp	plgv_ex1

plgv_skp8:
;*** fetch data ***
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_FetchMode],y
	bpl	plgv_ex1
	jsr	pl_Fetch
	
plgv_ex1:
	rts


;**************************************************************************
;**
;** Fetch
;** Acc=CodeByte X=Voice
;**
;******
pl_Fetch:
	pha
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_PatternStep],y
	tay
	pla
	and	#$60
	beq	plf_Null
	cmp	#$20
	beq	plf_Pitch
	cmp	#$40
	beq	plf_Param

;*** fetch pitch+param ***
	lda	(PatternZP),y
	iny
	sta	pl_Temp1ZP
	lda	(PatternZP),y
	iny
	sta	pl_Temp2ZP
	jmp	plf_ex1

;*** set to zero ***
plf_Null:
	lda	#0
	sta	pl_Temp1ZP
	sta	pl_Temp2ZP
	jmp	plf_ex1
;*** fetch pitch ***
plf_Pitch:
	lda	(PatternZP),y
	iny
	sta	pl_Temp1ZP
	lda	#0
	sta	pl_Temp2ZP
	jmp	plf_ex1
;*** fetch param , pitch to $80 ***
plf_Param:
	lda	(PatternZP),y
	iny
	sta	pl_Temp2ZP
	lda	#$80
	sta	pl_Temp1ZP
	jmp	plf_ex1

plf_ex1:
	tya
	ldy	pl_VoiceOffset,x
	sta	[pl_VoiceData+vd_PatternStep],y

	lda	pl_Temp2ZP
	sta	[pl_VoiceData+vd_Param],y

	lda	pl_Temp1ZP
	cmp	#$80
	bne	plf_skp1
	lda	[pl_VoiceData+vd_Note],y
	ora	#$80
plf_skp1:
	sta	[pl_VoiceData+vd_Note],y

	rts




;**************************************************************************
;**
;** Retrig
;** X=Voice
;**
;******
pl_Retrig:
	pha
	tya
	pha
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_Note],y
	bmi	plrt_ex1

	lda	#0
	sta	[pl_VoiceData+vd_FreqOffset],y
	sta	[pl_VoiceData+vd_FreqOffsetHigh],y
	sta	[pl_VoiceData+vd_ArpStep],y
	sta	[pl_VoiceData+vd_ArpOffset],y

	lda	[pl_VoiceData+vd_Param],y
	and	#$f0
	cmp	#$30
	bne	plrt_ex1
	lda	[pl_VoiceData+vd_Param],y
	asl
	asl
	asl
	tay
	lda	pl_Arpeggios,y
	ldy	pl_VoiceOffset,x
	sta	[pl_VoiceData+vd_ArpOffset],y

plrt_ex1:
	pla
	tay
	pla
	rts


;**************************************************************************
;**
;** CheckEffects
;** X=Voice
;**
;******
pl_CheckEffects:

;*** Get VoiceData ***
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_Note],y
	and	#$7f
	cpx	#$04
	beq	plce_VolumeTempo


	rts

plce_VolumeTempo:
	and	#$f0
	beq	plcevt_ex1
	lsr
	lsr
	lsr
	lsr
	sta	pl_Speed
plcevt_ex1:
	rts


;**************************************************************************
;**
;** PlayVoice
;** X=Voice
;**
;******
pl_PlayVoice:

;*** Get VoiceData ***
	ldy	pl_VoiceOffset,x

;Calculate FreqOffset/2 (Signed) and put in pl_Temp1ZP
	lda	[pl_VoiceData+vd_FreqOffset],y
	sta	pl_Temp1ZP
	lda	[pl_VoiceData+vd_FreqOffsetHigh],y
	lsr
	ror	pl_Temp1ZP
	lsr
	ror	pl_Temp1ZP
	lsr
	ror	pl_Temp1ZP
	lsr
	ror	pl_Temp1ZP

;Get note in ACC and jump
	lda	[pl_VoiceData+vd_Note],y
	and	#$7f
	cpx	#$04			;Is VOL?
	beq	plpv_VolumeTempo
	cpx	#$03			;Is noise?
	beq	plpv_Noise

;*** Play Note ***
	clc
	adc	[pl_VoiceData+vd_ArpOffset],y	;Add Arpeggio
	tay
	lda	pl_FreqTab,y
	beq	plpv_skp1
	clc
	adc	pl_Temp1ZP
	ora	#$80
plpv_skp1:
	sta	$900a,x
	rts

plpv_Noise:
;*** Play Noise ***
	cmp	#$00
	beq	pplvn_skp1
	clc
	adc	[pl_VoiceData+vd_ArpOffset],y	;Add arpeggio
	clc
	adc	pl_Temp1ZP
	ora	#$80		;SetGate
pplvn_skp1:
	sta	$900a,x
	rts

plpv_VolumeTempo:
;*** Handle Volume ***

	and	#$0f
	sta	pl_Temp1ZP
	lda	$900e
	and	#$f0
	ora	pl_Temp1ZP
	sta	$900e
pplvv_ex1:
	rts



;**************************************************************************
;**
;** UpdateVoice
;** X=Voice
;**
;******
pl_UpdateVoice:

;*** Fix Effects ***
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_Param],y
	pha
	and	#$0f
	sta	pl_Temp1ZP
	pla
	and	#$f0
	cmp	#$10
	beq	pl_PortamentoUp
	cmp	#$20
	beq	pl_PortamentoDown
	cmp	#$30
	beq	pl_Arpeggio
	cmp	#$50
	beq	pl_PortamentoUpSlow
	cmp	#$60
	beq	pl_PortamentoDownSlow

	rts

pl_PortamentoUp:
	asl	pl_Temp1ZP
	asl	pl_Temp1ZP
	asl	pl_Temp1ZP
	lda	[pl_VoiceData+vd_FreqOffset],y
	clc
	adc	pl_Temp1ZP
	sta	[pl_VoiceData+vd_FreqOffset],y
	lda	[pl_VoiceData+vd_FreqOffsetHigh],y
	adc	#0
	sta	[pl_VoiceData+vd_FreqOffsetHigh],y
	rts
pl_PortamentoDown:
	asl	pl_Temp1ZP
	asl	pl_Temp1ZP
	asl	pl_Temp1ZP
	lda	[pl_VoiceData+vd_FreqOffset],y
	sec
	sbc	pl_Temp1ZP
	sta	[pl_VoiceData+vd_FreqOffset],y
	lda	[pl_VoiceData+vd_FreqOffsetHigh],y
	sbc	#0
	sta	[pl_VoiceData+vd_FreqOffsetHigh],y
	rts
pl_PortamentoUpSlow:
	asl	pl_Temp1ZP
	lda	[pl_VoiceData+vd_FreqOffset],y
	clc
	adc	pl_Temp1ZP
	sta	[pl_VoiceData+vd_FreqOffset],y
	lda	[pl_VoiceData+vd_FreqOffsetHigh],y
	adc	#0
	sta	[pl_VoiceData+vd_FreqOffsetHigh],y
	rts
pl_PortamentoDownSlow:
	asl	pl_Temp1ZP
	lda	[pl_VoiceData+vd_FreqOffset],y
	sec
	sbc	pl_Temp1ZP
	sta	[pl_VoiceData+vd_FreqOffset],y
	lda	[pl_VoiceData+vd_FreqOffsetHigh],y
	sbc	#0
	sta	[pl_VoiceData+vd_FreqOffsetHigh],y
	rts
pl_Arpeggio:
	lda	[pl_VoiceData+vd_ArpStep],y
	and	#%111
	clc
	adc	#1
	sta	[pl_VoiceData+vd_ArpStep],y
	asl	pl_Temp1ZP
	asl	pl_Temp1ZP
	asl	pl_Temp1ZP
	clc
	adc	pl_Temp1ZP
	tay
	lda	pl_Arpeggios,y
	ldy	pl_VoiceOffset,x
	sta	[pl_VoiceData+vd_ArpOffset],y
	rts

; song data
	include	djungel-zagor.asm

; eof
