;**************************************************************************
;**
;** FILE  runner.asm
;** Copyright (c) 1994, 2001 Daniel Kahlin
;** Written by Daniel Kahlin <daniel@kahlin.net>
;**
;** DESCRIPTION
;**   runner for packed vic-tracker tunes.  Uses player.asm.
;**
;******
	PROCESSOR 6502
	seg	code
	org	$2000


ColorZP		EQU	$fd
ScreenRAM	EQU	$1000
ColorRAM	EQU	$9400


s:
	jsr	s_Screen

	sei
	jsr	pl_Init

s_lp1:
	jsr	Frame

	lda	#$6a
s_lp2:
	cmp	$9004
	bne	s_lp2
s_lp3:
	cmp	$9004
	beq	s_lp3
	bne	s_lp1	;always



Frame:
	lda	#$e0+8
	sta	$900f
	jsr	pl_Play
	lda	#$e6+8
	sta	$900f

	lda	pl_Count
	cmp	pl_Speed
	bne	f_ex1
	ldx	#0
f_lp1:
	lda	ScreenRAM+[22*9],x
	sta	ScreenRAM+[22*8],x
	inx
	bne	f_lp1
f_ex1:
	jsr	ShowData
	rts


ShowData:
	ldy	#[22*0]
	sty	YTemp
	ldx	#0
sd_lp6:
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_PattlistStep],y
	jsr	PutHex
	inc	YTemp
	inc	YTemp
	inx
	cpx	#5
	bne	sd_lp6

	ldy	#[22*1]
	sty	YTemp
	ldx	#0
sd_lp1:
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_CurrentPattern],y
	jsr	PutHex
	inc	YTemp
	inc	YTemp
	inx
	cpx	#5
	bne	sd_lp1

	ldy	#[22*2]	
	sty	YTemp
	ldx	#0
sd_lp2:
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_PatternStep],y
	jsr	PutHex
	inc	YTemp
	inc	YTemp
	inx
	cpx	#5
	bne	sd_lp2

	ldy	#[22*3]
	sty	YTemp
	ldx	#0
sd_lp3:
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_FetchMode],y
	jsr	PutHex
	inc	YTemp
	inc	YTemp
	inx
	cpx	#5
	bne	sd_lp3


	ldy	#[22*4]
	sty	YTemp
	ldx	#0
sd_lp7:
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_FreqOffset],y
	jsr	PutHex
	inc	YTemp
	inc	YTemp
	inx
	cpx	#5
	bne	sd_lp7

	ldy	#[22*5]
	sty	YTemp
	ldx	#0
sd_lp8:
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_FreqOffsetHigh],y
	jsr	PutHex
	inc	YTemp
	inc	YTemp
	inx
	cpx	#5
	bne	sd_lp8

	ldy	#[22*6]
	sty	YTemp
	ldx	#0
sd_lp9:
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_ArpOffset],y
	jsr	PutHex
	inc	YTemp
	inc	YTemp
	inx
	cpx	#5
	bne	sd_lp9



	ldy	#[22*6]+2
	sty	YTemp
	ldx	#0
sd_lp4:
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_Note],y
	jsr	PutHex2
	inc	YTemp
	inc	YTemp
	inx
	cpx	#5
	bne	sd_lp4

	ldy	#[22*6]+4
	sty	YTemp
	ldx	#0
sd_lp5:
	ldy	pl_VoiceOffset,x
	lda	[pl_VoiceData+vd_Param],y
	jsr	PutHex2
	inc	YTemp
	inc	YTemp
	inx
	cpx	#5
	bne	sd_lp5


	rts


PutHex:
	stx	XTemp
	pha
	lsr
	lsr
	lsr
	lsr
	jsr	ph_Put
	pla
	and	#$0f
	jsr	ph_Put
	ldx	XTemp
	rts
ph_Put:
	tax
	ldy	YTemp
	lda	HTab,x
	sta	ScreenRAM,y
	inc	YTemp
	rts

PutHex2:
	stx	XTemp
	pha
	lsr
	lsr
	lsr
	lsr
	jsr	ph_Put2
	pla
	and	#$0f
	jsr	ph_Put2
	ldx	XTemp
	rts
ph_Put2:
	tax
	ldy	YTemp
	lda	HTab,x
	sta	ScreenRAM+[22*10],y
	inc	YTemp
	rts

XTemp:
	dc.b	0
YTemp:
	dc.b	0
HTab:
	dc.b	"0123456789",1,2,3,4,5,6


s_Screen:
	lda	#147
	jsr	$ffd2
	ldx	#0
	txa
s_lp4:
	sta	ColorRAM,x
	sta	ColorRAM+$100,x
	inx
	bne	s_lp4

	lda	#>[ColorRAM+[22*8]]
	sta	ColorZP+1
	lda	#<[ColorRAM+[22*8]]
	sta	ColorZP

	ldx	#8
sc_lp1:
	ldy	#21
sc_lp2:
	lda	ColorTab,y
	sta	(ColorZP),y	
	dey
	bpl	sc_lp2
	lda	ColorZP
	clc
	adc	#22
	sta	ColorZP
	bcc	sc_skp1
	inc	ColorZP+1
sc_skp1:
	dex
	bpl	sc_lp1

	lda	#$e6+8
	sta	$900f

	ldx	#44-1
ss_lp1:
	lda	Bonus_MSG,x
	and	#$3f
	ora	#$80
	sta	ScreenRAM+22*21,x
	lda	#6
	sta	ColorRAM+22*21,x
	dex
	bpl	ss_lp1
	rts


Bonus_MSG:
	dc.b	"                      "
	dc.b	"    VIC-PLAYER 1.0    "
	rts

ColorTab:
	dc.b	0,0,2,2,2,2,6,6,6,6,2,2,2,2,6,6,6,6,2,2,2,2


	org	$2300
start:
	INCLUDE	player.asm
end:
	ECHO	"length: ",end-start," (",[end-start]/254," blocks)"

; eof

